// 初始化
mui.init({
	keyEventBind: {
		backbutton: false,
		menubutton: false
	}
});

// 所有方法都放到这里
mui.plusReady(function() {
	var detailId = qiao.h.getItem("newsid");
	mui.ajax(postUrl + "GetNewInfo", {
		data: {
			id: detailId
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			if(data.status == 1) {
				document.getElementById("detailTitle").innerHTML = data.title;
				var contenthtml = data.content.replace('<img src=\"', '<img src=\"' + fileUrl);
				document.getElementById("detailContent").innerHTML = contenthtml;
			} else {
				mui.toast("获取数据出错！");
				return false;
			}
		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			console.log(type);
		}
	});
});