// 初始化
mui.init();
var subpages = ['send.html', 'find.html', 'servers.html', 'my.html'];
var subpage_style = {
	top: '45px',
	bottom: '51px',
	scrollIndicator: "none"
};
var main = null;
var aniShow = {};
var floatw = null;
// 所有方法都放到这里
mui.plusReady(function() {
	main = qiao.h.indexPage();
	//版本更新
	var wgtVer = null;
	var checkUrl = "";
	var wgtUrl = "";
	function checkUpdate() {
		// 获取本地应用资源版本号
		plus.runtime.getProperty(plus.runtime.appid, function(inf) {
			wgtVer = inf.version;
			console.log("当前应用版本：" + wgtVer);
		});
		//      plus.nativeUI.showWaiting("检测更新...");
		var xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function() {
			switch(xhr.readyState) {
				case 4:
					//                  plus.nativeUI.closeWaiting();
					if(xhr.status == 200) {
						console.log("检测更新成功：" + xhr.responseText);
						var newVer = xhr.responseText;
						if(compareVersion(wgtVer, newVer)) {
							downWgt(); // 下载升级包
						} else {
							//                          plus.nativeUI.alert("无新版本可更新！");
						}
					} else {
						console.log("检测更新失败！");
						//                      plus.nativeUI.alert("检测更新失败！");
					}
					break;
				default:
					break;
			}
		}
		xhr.open('GET', checkUrl);
		xhr.send();
	}

	function downWgt() {
		var w = plus.nativeUI.showWaiting("　　 开始下载更新　　");
		var options = {
			filename: "_doc/update/"
		};
		//删除下载的文件
		plus.io.resolveLocalFileSystemURL("_doc/update", function(entry) {
			entry.removeRecursively(function(a) {}, function(e1) {});
		}, function(e) {
			console.log(e);
		});
		var dtask = plus.downloader.createDownload(wgtUrl, options, function(d, status) {
			if(status == 200) {
				console.log("下载wgt成功：" + d.filename);
				setTimeout(installWgt(d.filename), 2000); // 安装wgt包
			} else {
				console.log("下载wgt失败！");
				plus.nativeUI.alert("下载更新失败！");
			}
		});
		dtask.addEventListener("statechanged", function(task, status) {
			switch(task.state) {
				case 1: // 开始
					w.setTitle("　　 开始下载...　　 ");
					break;
				case 2: // 已连接到服务器
					w.setTitle("　　 开始下载更新　　 ");
					break;
				case 3:
					var a = task.downloadedSize / task.totalSize * 100;
					//console.log(a)
					w.setTitle("　　 已下载" + parseInt(a) + "%　　 ");
					break;
				case 4: // 下载完成
					w.close();
					break;
			}
		});
		dtask.start();
	}

	// 更新应用资源

	function installWgt(path) {
		plus.nativeUI.showWaiting("在线安装更新中...");
		plus.runtime.install(path, {}, function() {
			plus.nativeUI.closeWaiting();
			//自动在线升级不重启
			plus.nativeUI.alert("更新完成！", function() {
				plus.runtime.restart();
			});
			console.log("安装wgt文件成功！");
		}, function(e) {
			console.log("安装wgt文件失败[" + e.code + "]：" + e.message);
			plus.nativeUI.closeWaiting();
			plus.nativeUI.alert("更新失败");

		});
	}
	/**
	 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
	 * @param {String} ov
	 * @param {String} nv
	 * @return {Boolean}
	 */

	function compareVersion(ov, nv) {
		if(!ov || !nv || ov == "" || nv == "") {
			return false;
		}
		var b = false,
			ova = ov.split(".", 4),
			nva = nv.split(".", 4);
		for(var i = 0; i < ova.length && i < nva.length; i++) {
			var so = ova[i],
				no = parseInt(so),
				sn = nva[i],
				nn = parseInt(sn);
			if(nn > no || sn.length > so.length) {
				return true;
			} else if(nn < no) {
				return false;
			}
		}
		if(nva.length > ova.length && 0 == nv.indexOf(ov)) {
			return true;
		}
	}
	//自动在线更新
	mui.ajax({
		url: postUrl + 'IosUpdateVer',
		dataType: "json",
		data: {},
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			if(data.status == 1) {
				checkUrl = data.cUrl;
				wgtUrl = data.wgtUrl;
				checkUpdate();
			}
		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			console.log(type);
			//console.log(JSON.stringify(xhr));
		}
	})
	for(var i = 0; i < 4; i++) {
		var temp = {};
		var sub = plus.webview.create(subpages[i], subpages[i], subpage_style);
		if(i > 0) {
			sub.hide();
		} else {
			temp[subpages[i]] = "true";
			mui.extend(aniShow, temp);
		}
		main.append(sub);
		sub.addEventListener('loaded', function() {
			setTimeout(function() {
				plus.navigator.closeSplashscreen();
			}, 5000);
		});
	}
	//当前激活选项
	var activeTab = subpages[0];
	var title = document.getElementById("title");
	//选项卡点击事件
	mui('.mui-bar-tab').on('tap', 'a', function(e) {
		var targetTab = this.getAttribute('href');
		if(targetTab == activeTab) {
			return;
		}
		//更换标题
		title.innerHTML = this.querySelector('.mui-tab-label').innerHTML;
		//显示目标选项卡
		//若为iOS平台或非首次显示，则直接显示
		if(mui.os.ios || aniShow[targetTab]) {
			plus.webview.show(targetTab);
		} else {
			//否则，使用fade-in动画，且保存变量
			var temp = {};
			temp[targetTab] = "true";
			mui.extend(aniShow, temp);
			plus.webview.show(targetTab, "fade-in", 300);
		}
		//隐藏当前;
		plus.webview.hide(activeTab);
		//更改当前活跃的选项卡
		activeTab = targetTab;
	});

	var templates = {};
	var getTemplate = function(name, header, content) {
		var template = templates[name];
		if(!template) {
			//预加载共用父模板；
			var headerWebview = mui.preload({
				url: header,
				id: name + "-main",
				styles: {
					popGesture: "hide",
				},
				extras: {
					mType: 'main'
				}
			});
			//预加载共用子webview
			var subWebview = mui.preload({
				url: !content ? "" : content,
				id: name + "-sub",
				styles: {
					top: '45px',
					bottom: '0px',
				},
				extras: {
					mType: 'sub'
				}
			});
			subWebview.addEventListener('loaded', function() {
				setTimeout(function() {
					subWebview.show();
				}, 50);
			});
			subWebview.hide();
			headerWebview.append(subWebview);
			//iOS平台支持侧滑关闭，父窗体侧滑隐藏后，同时需要隐藏子窗体；
			if(mui.os.ios) { //5+父窗体隐藏，子窗体还可以看到？不符合逻辑吧？
				headerWebview.addEventListener('hide', function() {
					subWebview.hide("none");
				});
			}
			templates[name] = template = {
				name: name,
				header: headerWebview,
				content: subWebview,
			};
		}
		return template;
	};
	var initTemplates = function() {
		getTemplate('default', 'template.html');
	};
	//初始化模板
	initTemplates();
	document.getElementById("help").addEventListener('tap', function() {
		var template = plus.webview.getWebviewById("default-main");
		//获得共用子webview
		var subWebview = template.children()[0];
		//通知模板修改标题，并显示隐藏右上角图标；
		mui.fire(template, 'updateHeader', {
			title: "帮助中心"
		});
		if(subWebview.getURL() != "help.html") {
			subWebview.loadURL("help.html");
		} else {
			subWebview.show();
		}
		template.show('slide-in-right', 150);
	});
	floatw = plus.webview.create("menu.html", "menu", {
		background: 'transparent',
		zindex: 10,
	}); // 创建悬浮窗口
	function floatWebview() {
		if(floatw) { // 避免快速多次点击创建多个窗口
			floatw.show("fade-in");
		} else {
			floatw = plus.webview.create("menu.html", "menu", {
				background: 'transparent',
				zindex: 10,
			});
			floatw.show("fade-in");
		}
	}
	window.addEventListener('loadmenu', function(event) {
		plus.webview.getWebviewById("menu").close();
		floatw = plus.webview.create("menu.html", "menu", {
			background: 'transparent',
			zindex: 10,
		}); // 创建悬浮窗口
	});
	document.getElementById("write").addEventListener('tap', function() {
		if(qiao.h.getItem("username") != "" && qiao.h.getItem("username") != null) {
			floatWebview();
		} else {
			qiao.h.alert("您还没有登录！");
		}
	});
	if(plus.os.name == "Android") {
		var context = plus.android.importClass("android.content.Context");
		var locationManager = plus.android.importClass("android.location.LocationManager");
		var main = plus.android.runtimeMainActivity();
		var mainSvr = main.getSystemService(context.LOCATION_SERVICE);
		if(!mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER)) {
			var message = "GPS设备未开启不能使用定位及导航功能";
			var title = "GPS未启用";
			var alertCB = function() {
				var Intent = plus.android.importClass("android.content.Intent");
				var mIntent = new Intent('android.settings.LOCATION_SOURCE_SETTINGS');
				main.startActivity(mIntent); //打开GPS设置
			}
			qiao.h.insertItem("selfpoint", "");
			plus.nativeUI.alert(message, alertCB, title);
		} else {
			plus.geolocation.getCurrentPosition(function(p) {
				var PX = p.coords.longitude;
				var PY = p.coords.latitude;
				var proivice = p.address.province;
				selfpoint = PY + "," + PX;
				qiao.h.insertItem("selfpoint", selfpoint);
			}, function(e) {
				console.log("Geolocation error: " + e.message);
			});
		}
	} else {
		//		var CLLocationManager = plus.ios.import("CLLocationManager");
		//		var authorizationStatus = CLLocationManager.authorizationStatus();
		//		if(authorizationStatus == 3 || authorizationStatus == 4) {
		plus.geolocation.getCurrentPosition(function(p) {
			var PX = p.coords.longitude;
			var PY = p.coords.latitude;
			var proivice = p.address.province;
			selfpoint = PY + "," + PX;
			qiao.h.insertItem("selfpoint", selfpoint);
		}, function(e) {
			console.log("Geolocation error: " + e.message);
		});
		//		} else {
		//			qiao.h.insertItem("selfpoint", "");
		//					var message = "GPS设备未开启不能使用定位及导航功能";
		//						plus.nativeUI.alert(message);
		//		}
	}

	// 退出
	mui.back = function() {
		qiao.h.exit();
	};
});