// 初始化
mui.init({
	keyEventBind: {
		backbutton: false,
		menubutton: false,

	},
	gestureConfig: {
		longtap: true
	}
});

var tapId = null;
// 所有的方法都放到这里
mui.plusReady(function() {
	// 获取列表
	initList();

	// 右滑菜单
//	window.addEventListener('swiperight', function() {
//		qiao.h.indexPage().evalJS("opMenu();");
//	});

	// 网站公告
	qiao.on('#todolist li', 'tap', function() {
		qiao.h.insertItem("newsid", "" + $(this).data('id') + "");
		var detailId = qiao.h.getItem("newsid");
		var template = plus.webview.getWebviewById("default-main");
		//获得共用子webview
		var subWebview = template.children()[0];
		//通知模板修改标题，并显示隐藏右上角图标；
		mui.fire(template, 'updateHeader', {
			title: "网站公告"
		});
		if(subWebview.getURL() != "detail.html") {
			subWebview.loadURL("detail.html");
		} else {
			subWebview.show();
		}
		template.show('slide-in-bottom', 150);
	});
	
	// 4大类信息
	qiao.on('#fourtype li', 'tap', function() {
		var urls = $(this).data('id');
		var title = this.getAttribute('id');
		var template = plus.webview.getWebviewById("default-main");
		//获得共用子webview
		var subWebview = template.children()[0];
		//通知模板修改标题，并显示隐藏右上角图标；
		mui.fire(template, 'updateHeader', {
			title: title
		});
		if(subWebview.getURL() != urls) {
			subWebview.loadURL(urls);
		} else {
			subWebview.show();
		}
		template.show('slide-in-right', 150);
	});

});
	document.getElementById("moreNews").addEventListener('tap', function() {
		var template = plus.webview.getWebviewById("default-main");
		//获得共用子webview
		var subWebview = template.children()[0];
		//通知模板修改标题，并显示隐藏右上角图标；
		mui.fire(template, 'updateHeader', {
			title: "网站公告"
		});
		if(subWebview.getURL() != "newlist.html") {
			subWebview.loadURL("newlist.html");
		} else {
			subWebview.show();
		}
		template.show('slide-in-right', 150);
	});
// 初始化网站公告
function initList() {
	//qmask.show();
	var $ul = $('#todolist').empty();
	mui.ajax(postUrl + "GetToplist", {
		data: {
			channel: 'news',
			cateid: 52,
			top: 10
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			//服务器返回响应，根据响应结果，分析是否登录成功；
			for(i = 0; i < data.length; i++) {
				$ul.append(genLi(data[i]));
			}
			showList($ul);
		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			console.log(type);
		}
	});

	//qmask.hide();
}

function genLi(data) {
	var id = data.id;
	var title = data.title;
	var li =
		'<li id="todoli_' + id + '" data-id="' + id + '">' +
		'<a href="">' + title + '</a>' +
		'</li>';
	return li;
}

function showList(ul) {
	if(ul.find('li').size() > 0 && ul.is(':hidden')) ul.show();
}